#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "mygrid.h"

MyGrid::MyGrid(int w, int l, double cls, double nl, double t, double n, double **s) :
	RFGrid2D(w, l, cls, t, s)
{
   NCLength = nl;
   Neighbourliness = n;
   HGrid = new RGrid2D(w - 1, l, nl, HDiff);
   VGrid = new RGrid2D(w, l - 1, nl, VDiff);
}

float MyGrid::Iterate(float Increment)
{
   int i, j;
   double Offset, LowThreshold, HighThreshold;

   HGrid->Iterate(Increment);
   VGrid->Iterate(Increment);

   for (i = 0; i < Width - 1; i++)
     {
	for (j = 0; j < Length; j++)
	  HConnected[i][j] = (fabs(HGrid->Nodes[i][j]) < Threshold);
     }
   for (i = 0; i < Width; i++)
     {
	for (j = 0; j < Length - 1; j++)
	  {
	     /* All this stuff is unnecessary, but I can't get rid of it */
	     Offset = Neighbourliness * VGrid->Nodes[i][j];
	     if (Offset > Threshold)
	       Offset = Threshold;
	     else if (Offset < -Threshold)
	       Offset = -Threshold;
	     LowThreshold = -Threshold - Offset;
	     HighThreshold = Threshold - Offset;
	     /* ...up to here */

	     VConnected[i][j] = (VGrid->Nodes[i][j] > -Threshold);
	     VConnected[i][j] &= (VGrid->Nodes[i][j] < Threshold);
	  }
     }
   return RGrid2D::Iterate(Increment);
}

