class RGrid2D
{
 protected:
   int Width, Length;
   double CLengthSqu;
   double **HCurr;
   double **VCurr;
   double LargestChange;
   
   void IterateH(int i, int j, float Increment);
   void IterateV(int i, int j, float Increment);
   void CalcNode(int i, int j, float Increment);
   void PrintHeader(FILE *f, const char *hfile);
   void PrintNodes(FILE *f);

 public:
   double **Sources;
   double **Nodes;
   double **HDiff;
   double **VDiff;
   int **HConnected;
   int **VConnected;

   RGrid2D(int Width, int Length, double CLengthSqu, double **Sources);
   ~RGrid2D();
   void InitialiseNodes();
   double Iterate(float Increment);
   void PrintNodeTable();
   void PrintHCurrTable();
   void PrintVCurrTable();
   void PrintSegmentation();
   void PrintPostscript(const char *psfile);
   void PrintEdgesPostscript(const char *psfile);
};

