#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "rfgrid.h"

RFGrid2D::RFGrid2D(int w, int l, double cls, double t, double **s) :
	RGrid2D(w, l, cls, s)
{
   Threshold = t;
}

float RFGrid2D::Iterate(float Increment)
{
   int i, j;

   for (i = 0; i < Width - 1; i++)
     {
	for (j = 0; j < Length; j++)
	  HConnected[i][j] = (fabs(HDiff[i][j]) < Threshold);
     }
   for (i = 0; i < Width; i++)
     {
	for (j = 0; j < Length - 1; j++)
	  VConnected[i][j] = (VDiff[i][j] < Threshold);
     }
   return RGrid2D::Iterate(Increment);
}

